/* GestureTracker.c generated by valac 0.56.17, the Vala compiler
 * generated from GestureTracker.vala, do not modify */

/*
 * Copyright 2021 elementary, Inc (https://elementary.io)
 *           2021 José Expósito <jose.exposito89@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <clutter/clutter.h>

#define GALA_GESTURE_TRACKER_SUCCESS_PERCENTAGE_THRESHOLD 0.2
#define GALA_GESTURE_TRACKER_SUCCESS_VELOCITY_THRESHOLD 0.003
#define GALA_GESTURE_TRACKER_ANIMATION_BASE_VELOCITY 0.002
#define GALA_GESTURE_TRACKER_MAX_VELOCITY 0.01
#define GALA_GESTURE_TRACKER_DURATION_MULTIPLIER 3
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_GESTURE_BACKEND (gala_gesture_backend_get_type ())
#define GALA_GESTURE_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_BACKEND, GalaGestureBackend))
#define GALA_IS_GESTURE_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_BACKEND))
#define GALA_GESTURE_BACKEND_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_GESTURE_BACKEND, GalaGestureBackendIface))

typedef struct _GalaGestureBackend GalaGestureBackend;
typedef struct _GalaGestureBackendIface GalaGestureBackendIface;

#define GALA_TYPE_GESTURE (gala_gesture_get_type ())
#define GALA_GESTURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE, GalaGesture))
#define GALA_GESTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE, GalaGestureClass))
#define GALA_IS_GESTURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE))
#define GALA_IS_GESTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE))
#define GALA_GESTURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE, GalaGestureClass))

typedef struct _GalaGesture GalaGesture;
typedef struct _GalaGestureClass GalaGestureClass;
enum  {
	GALA_GESTURE_BACKEND_ON_GESTURE_DETECTED_SIGNAL,
	GALA_GESTURE_BACKEND_ON_BEGIN_SIGNAL,
	GALA_GESTURE_BACKEND_ON_UPDATE_SIGNAL,
	GALA_GESTURE_BACKEND_ON_END_SIGNAL,
	GALA_GESTURE_BACKEND_NUM_SIGNALS
};
static guint gala_gesture_backend_signals[GALA_GESTURE_BACKEND_NUM_SIGNALS] = {0};

#define GALA_TYPE_GESTURE_TRACKER (gala_gesture_tracker_get_type ())
#define GALA_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker))
#define GALA_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))
#define GALA_IS_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TRACKER))
#define GALA_IS_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_TRACKER))
#define GALA_GESTURE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))

typedef struct _GalaGestureTracker GalaGestureTracker;
typedef struct _GalaGestureTrackerClass GalaGestureTrackerClass;
typedef struct _GalaGestureTrackerPrivate GalaGestureTrackerPrivate;

#define GALA_TYPE_GESTURE_SETTINGS (gala_gesture_settings_get_type ())
#define GALA_GESTURE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_SETTINGS, GalaGestureSettings))
#define GALA_GESTURE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_SETTINGS, GalaGestureSettingsClass))
#define GALA_IS_GESTURE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_SETTINGS))
#define GALA_IS_GESTURE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_SETTINGS))
#define GALA_GESTURE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_SETTINGS, GalaGestureSettingsClass))

typedef struct _GalaGestureSettings GalaGestureSettings;
typedef struct _GalaGestureSettingsClass GalaGestureSettingsClass;

#define GALA_TYPE_TOUCHEGG_BACKEND (gala_touchegg_backend_get_type ())
#define GALA_TOUCHEGG_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_TOUCHEGG_BACKEND, GalaToucheggBackend))
#define GALA_TOUCHEGG_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_TOUCHEGG_BACKEND, GalaToucheggBackendClass))
#define GALA_IS_TOUCHEGG_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_TOUCHEGG_BACKEND))
#define GALA_IS_TOUCHEGG_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_TOUCHEGG_BACKEND))
#define GALA_TOUCHEGG_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_TOUCHEGG_BACKEND, GalaToucheggBackendClass))

typedef struct _GalaToucheggBackend GalaToucheggBackend;
typedef struct _GalaToucheggBackendClass GalaToucheggBackendClass;

#define GALA_TYPE_SCROLL_BACKEND (gala_scroll_backend_get_type ())
#define GALA_SCROLL_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SCROLL_BACKEND, GalaScrollBackend))
#define GALA_SCROLL_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SCROLL_BACKEND, GalaScrollBackendClass))
#define GALA_IS_SCROLL_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SCROLL_BACKEND))
#define GALA_IS_SCROLL_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SCROLL_BACKEND))
#define GALA_SCROLL_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SCROLL_BACKEND, GalaScrollBackendClass))

typedef struct _GalaScrollBackend GalaScrollBackend;
typedef struct _GalaScrollBackendClass GalaScrollBackendClass;
enum  {
	GALA_GESTURE_TRACKER_0_PROPERTY,
	GALA_GESTURE_TRACKER_SETTINGS_PROPERTY,
	GALA_GESTURE_TRACKER_MIN_ANIMATION_DURATION_PROPERTY,
	GALA_GESTURE_TRACKER_MAX_ANIMATION_DURATION_PROPERTY,
	GALA_GESTURE_TRACKER_ENABLED_PROPERTY,
	GALA_GESTURE_TRACKER_NUM_PROPERTIES
};
static GParamSpec* gala_gesture_tracker_properties[GALA_GESTURE_TRACKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef void (*GalaGestureTrackerOnBegin) (gdouble percentage, gpointer user_data);
typedef void (*GalaGestureTrackerOnUpdate) (gdouble percentage, gpointer user_data);
typedef void (*GalaGestureTrackerOnEnd) (gdouble percentage, gint completions, gint calculated_duration, gpointer user_data);
typedef struct _Block61Data Block61Data;
enum  {
	GALA_GESTURE_TRACKER_ON_GESTURE_DETECTED_SIGNAL,
	GALA_GESTURE_TRACKER_ON_GESTURE_HANDLED_SIGNAL,
	GALA_GESTURE_TRACKER_ON_BEGIN_SIGNAL,
	GALA_GESTURE_TRACKER_ON_UPDATE_SIGNAL,
	GALA_GESTURE_TRACKER_ON_END_SIGNAL,
	GALA_GESTURE_TRACKER_NUM_SIGNALS
};
static guint gala_gesture_tracker_signals[GALA_GESTURE_TRACKER_NUM_SIGNALS] = {0};

struct _GalaGestureBackendIface {
	GTypeInterface parent_iface;
	void (*prepare_gesture_handling) (GalaGestureBackend* self);
};

struct _GalaGestureTracker {
	GObject parent_instance;
	GalaGestureTrackerPrivate * priv;
};

struct _GalaGestureTrackerClass {
	GObjectClass parent_class;
};

struct _GalaGestureTrackerPrivate {
	GalaGestureSettings* _settings;
	gint _min_animation_duration;
	gint _max_animation_duration;
	gboolean _enabled;
	GalaToucheggBackend* touchpad_backend;
	GalaScrollBackend* scroll_backend;
	GeeArrayList* handlers;
	gdouble previous_percentage;
	guint64 previous_time;
	gdouble percentage_delta;
	gdouble velocity;
};

struct _Block61Data {
	int _ref_count_;
	GalaGestureTracker* self;
	GalaGestureTrackerOnBegin on_begin_handler;
	gpointer on_begin_handler_target;
	GDestroyNotify on_begin_handler_target_destroy_notify;
	GalaGestureTrackerOnUpdate on_update_handler;
	gpointer on_update_handler_target;
	GDestroyNotify on_update_handler_target_destroy_notify;
	GalaGestureTrackerOnEnd on_end_handler;
	gpointer on_end_handler_target;
	GDestroyNotify on_end_handler_target_destroy_notify;
};

static gint GalaGestureTracker_private_offset;
static gpointer gala_gesture_tracker_parent_class = NULL;

VALA_EXTERN GType gala_gesture_backend_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureBackend, g_object_unref)
VALA_EXTERN void gala_gesture_backend_prepare_gesture_handling (GalaGestureBackend* self);
static void gala_gesture_backend_real_prepare_gesture_handling (GalaGestureBackend* self);
VALA_EXTERN gpointer gala_gesture_ref (gpointer instance);
VALA_EXTERN void gala_gesture_unref (gpointer instance);
VALA_EXTERN GParamSpec* gala_param_spec_gesture (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void gala_value_set_gesture (GValue* value,
                             gpointer v_object);
VALA_EXTERN void gala_value_take_gesture (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer gala_value_get_gesture (const GValue* value);
VALA_EXTERN GType gala_gesture_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGesture, gala_gesture_unref)
static void g_cclosure_user_marshal_BOOLEAN__GALA_GESTURE_UINT (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__DOUBLE_UINT64 (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GType gala_gesture_backend_get_type_once (void);
VALA_EXTERN GType gala_gesture_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTracker, g_object_unref)
VALA_EXTERN GType gala_gesture_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureSettings, g_object_unref)
VALA_EXTERN GType gala_touchegg_backend_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaToucheggBackend, g_object_unref)
VALA_EXTERN GType gala_scroll_backend_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaScrollBackend, g_object_unref)
VALA_EXTERN GalaGestureTracker* gala_gesture_tracker_new (gint min_animation_duration,
                                              gint max_animation_duration);
VALA_EXTERN GalaGestureTracker* gala_gesture_tracker_construct (GType object_type,
                                                    gint min_animation_duration,
                                                    gint max_animation_duration);
VALA_EXTERN void gala_gesture_tracker_enable_touchpad (GalaGestureTracker* self);
VALA_EXTERN GalaToucheggBackend* gala_touchegg_backend_get_default (void);
static gboolean gala_gesture_tracker_gesture_detected (GalaGestureTracker* self,
                                                GalaGestureBackend* backend,
                                                GalaGesture* gesture,
                                                guint32 timestamp);
static gboolean _gala_gesture_tracker_gesture_detected_gala_gesture_backend_on_gesture_detected (GalaGestureBackend* _sender,
                                                                                          GalaGesture* gesture,
                                                                                          guint32 timestamp,
                                                                                          gpointer self);
static void gala_gesture_tracker_gesture_begin (GalaGestureTracker* self,
                                         gdouble percentage,
                                         guint64 elapsed_time);
static void _gala_gesture_tracker_gesture_begin_gala_gesture_backend_on_begin (GalaGestureBackend* _sender,
                                                                        gdouble delta,
                                                                        guint64 time,
                                                                        gpointer self);
static void gala_gesture_tracker_gesture_update (GalaGestureTracker* self,
                                          gdouble percentage,
                                          guint64 elapsed_time);
static void _gala_gesture_tracker_gesture_update_gala_gesture_backend_on_update (GalaGestureBackend* _sender,
                                                                          gdouble delta,
                                                                          guint64 time,
                                                                          gpointer self);
static void gala_gesture_tracker_gesture_end (GalaGestureTracker* self,
                                       gdouble percentage,
                                       guint64 elapsed_time);
static void _gala_gesture_tracker_gesture_end_gala_gesture_backend_on_end (GalaGestureBackend* _sender,
                                                                    gdouble delta,
                                                                    guint64 time,
                                                                    gpointer self);
VALA_EXTERN void gala_gesture_tracker_enable_scroll (GalaGestureTracker* self,
                                         ClutterActor* actor,
                                         ClutterOrientation orientation);
VALA_EXTERN GalaGestureSettings* gala_gesture_tracker_get_settings (GalaGestureTracker* self);
VALA_EXTERN GalaScrollBackend* gala_scroll_backend_new (ClutterActor* actor,
                                            ClutterOrientation orientation,
                                            GalaGestureSettings* settings);
VALA_EXTERN GalaScrollBackend* gala_scroll_backend_construct (GType object_type,
                                                  ClutterActor* actor,
                                                  ClutterOrientation orientation,
                                                  GalaGestureSettings* settings);
VALA_EXTERN void gala_gesture_tracker_connect_handlers (GalaGestureTracker* self,
                                            GalaGestureTrackerOnBegin on_begin_handler,
                                            gpointer on_begin_handler_target,
                                            GDestroyNotify on_begin_handler_target_destroy_notify,
                                            GalaGestureTrackerOnUpdate on_update_handler,
                                            gpointer on_update_handler_target,
                                            GDestroyNotify on_update_handler_target_destroy_notify,
                                            GalaGestureTrackerOnEnd on_end_handler,
                                            gpointer on_end_handler_target,
                                            GDestroyNotify on_end_handler_target_destroy_notify);
static Block61Data* block61_data_ref (Block61Data* _data61_);
static void block61_data_unref (void * _userdata_);
static void ___lambda10_ (Block61Data* _data61_,
                   gdouble percentage);
static void ____lambda10__gala_gesture_tracker_on_begin (GalaGestureTracker* _sender,
                                                  gdouble percentage,
                                                  gpointer self);
static void ___lambda11_ (Block61Data* _data61_,
                   gdouble percentage);
static void ____lambda11__gala_gesture_tracker_on_update (GalaGestureTracker* _sender,
                                                   gdouble percentage,
                                                   gpointer self);
static void ___lambda12_ (Block61Data* _data61_,
                   gdouble percentage,
                   gint cancel_action,
                   gint duration);
static void ____lambda12__gala_gesture_tracker_on_end (GalaGestureTracker* _sender,
                                                gdouble percentage,
                                                gint completions,
                                                gint calculated_duration,
                                                gpointer self);
static void gala_gesture_tracker_disconnect_all_handlers (GalaGestureTracker* self);
VALA_EXTERN gfloat gala_gesture_tracker_animation_value (gfloat initial_value,
                                             gfloat target_value,
                                             gdouble percentage,
                                             gboolean rounded);
VALA_EXTERN gboolean gala_gesture_tracker_get_enabled (GalaGestureTracker* self);
static inline gdouble gala_gesture_tracker_applied_percentage (gdouble percentage,
                                                 gdouble percentage_delta);
static gint gala_gesture_tracker_calculate_end_animation_duration (GalaGestureTracker* self,
                                                            gdouble end_percentage,
                                                            gboolean cancel_action);
VALA_EXTERN gint gala_gesture_tracker_get_min_animation_duration (GalaGestureTracker* self);
VALA_EXTERN gint gala_gesture_tracker_get_max_animation_duration (GalaGestureTracker* self);
static void gala_gesture_tracker_set_settings (GalaGestureTracker* self,
                                        GalaGestureSettings* value);
static void gala_gesture_tracker_set_min_animation_duration (GalaGestureTracker* self,
                                                      gint value);
static void gala_gesture_tracker_set_max_animation_duration (GalaGestureTracker* self,
                                                      gint value);
VALA_EXTERN void gala_gesture_tracker_set_enabled (GalaGestureTracker* self,
                                       gboolean value);
static void g_cclosure_user_marshal_BOOLEAN__GALA_GESTURE (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__GALA_GESTURE_UINT (GClosure * closure,
                                                      GValue * return_value,
                                                      guint n_param_values,
                                                      const GValue * param_values,
                                                      gpointer invocation_hint,
                                                      gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__DOUBLE_INT_INT (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static GObject * gala_gesture_tracker_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
VALA_EXTERN GalaGestureSettings* gala_gesture_settings_new (void);
VALA_EXTERN GalaGestureSettings* gala_gesture_settings_construct (GType object_type);
static void gala_gesture_tracker_finalize (GObject * obj);
static GType gala_gesture_tracker_get_type_once (void);
static void _vala_gala_gesture_tracker_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_gesture_tracker_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static void
gala_gesture_backend_real_prepare_gesture_handling (GalaGestureBackend* self)
{
}

void
gala_gesture_backend_prepare_gesture_handling (GalaGestureBackend* self)
{
	GalaGestureBackendIface* _iface_;
#line 25 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Gestures/GestureTracker.vala"
	_iface_ = GALA_GESTURE_BACKEND_GET_INTERFACE (self);
#line 25 "../src/Gestures/GestureTracker.vala"
	if (_iface_->prepare_gesture_handling) {
#line 25 "../src/Gestures/GestureTracker.vala"
		_iface_->prepare_gesture_handling (self);
#line 377 "GestureTracker.c"
	}
}

static void
g_cclosure_user_marshal_BOOLEAN__GALA_GESTURE_UINT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__GALA_GESTURE_UINT) (gpointer data1, gpointer arg_1, guint32 arg_2, gpointer data2);
	register GMarshalFunc_BOOLEAN__GALA_GESTURE_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 19 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (return_value != NULL);
#line 19 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (n_param_values == 3);
#line 19 "../src/Gestures/GestureTracker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 19 "../src/Gestures/GestureTracker.vala"
		data1 = closure->data;
#line 19 "../src/Gestures/GestureTracker.vala"
		data2 = param_values->data[0].v_pointer;
#line 406 "GestureTracker.c"
	} else {
#line 19 "../src/Gestures/GestureTracker.vala"
		data1 = param_values->data[0].v_pointer;
#line 19 "../src/Gestures/GestureTracker.vala"
		data2 = closure->data;
#line 412 "GestureTracker.c"
	}
#line 19 "../src/Gestures/GestureTracker.vala"
	callback = (GMarshalFunc_BOOLEAN__GALA_GESTURE_UINT) (marshal_data ? marshal_data : cc->callback);
#line 19 "../src/Gestures/GestureTracker.vala"
	v_return = callback (data1, gala_value_get_gesture (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 19 "../src/Gestures/GestureTracker.vala"
	g_value_set_boolean (return_value, v_return);
#line 420 "GestureTracker.c"
}

static void
g_cclosure_user_marshal_VOID__DOUBLE_UINT64 (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DOUBLE_UINT64) (gpointer data1, gdouble arg_1, guint64 arg_2, gpointer data2);
	register GMarshalFunc_VOID__DOUBLE_UINT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 19 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (n_param_values == 3);
#line 19 "../src/Gestures/GestureTracker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 19 "../src/Gestures/GestureTracker.vala"
		data1 = closure->data;
#line 19 "../src/Gestures/GestureTracker.vala"
		data2 = param_values->data[0].v_pointer;
#line 445 "GestureTracker.c"
	} else {
#line 19 "../src/Gestures/GestureTracker.vala"
		data1 = param_values->data[0].v_pointer;
#line 19 "../src/Gestures/GestureTracker.vala"
		data2 = closure->data;
#line 451 "GestureTracker.c"
	}
#line 19 "../src/Gestures/GestureTracker.vala"
	callback = (GMarshalFunc_VOID__DOUBLE_UINT64) (marshal_data ? marshal_data : cc->callback);
#line 19 "../src/Gestures/GestureTracker.vala"
	callback (data1, g_value_get_double (param_values + 1), g_value_get_uint64 (param_values + 2), data2);
#line 457 "GestureTracker.c"
}

static void
gala_gesture_backend_default_init (GalaGestureBackendIface * iface,
                                   gpointer iface_data)
{
#line 19 "../src/Gestures/GestureTracker.vala"
	gala_gesture_backend_signals[GALA_GESTURE_BACKEND_ON_GESTURE_DETECTED_SIGNAL] = g_signal_new ("on-gesture-detected", GALA_TYPE_GESTURE_BACKEND, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__GALA_GESTURE_UINT, G_TYPE_BOOLEAN, 2, GALA_TYPE_GESTURE, G_TYPE_UINT);
#line 19 "../src/Gestures/GestureTracker.vala"
	gala_gesture_backend_signals[GALA_GESTURE_BACKEND_ON_BEGIN_SIGNAL] = g_signal_new ("on-begin", GALA_TYPE_GESTURE_BACKEND, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_UINT64, G_TYPE_NONE, 2, G_TYPE_DOUBLE, G_TYPE_UINT64);
#line 19 "../src/Gestures/GestureTracker.vala"
	gala_gesture_backend_signals[GALA_GESTURE_BACKEND_ON_UPDATE_SIGNAL] = g_signal_new ("on-update", GALA_TYPE_GESTURE_BACKEND, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_UINT64, G_TYPE_NONE, 2, G_TYPE_DOUBLE, G_TYPE_UINT64);
#line 19 "../src/Gestures/GestureTracker.vala"
	gala_gesture_backend_signals[GALA_GESTURE_BACKEND_ON_END_SIGNAL] = g_signal_new ("on-end", GALA_TYPE_GESTURE_BACKEND, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_UINT64, G_TYPE_NONE, 2, G_TYPE_DOUBLE, G_TYPE_UINT64);
#line 19 "../src/Gestures/GestureTracker.vala"
	iface->prepare_gesture_handling = gala_gesture_backend_real_prepare_gesture_handling;
#line 474 "GestureTracker.c"
}

 G_GNUC_NO_INLINE static GType
gala_gesture_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaGestureBackendIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_gesture_backend_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gala_gesture_backend_type_id;
	gala_gesture_backend_type_id = g_type_register_static (G_TYPE_INTERFACE, "GalaGestureBackend", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gala_gesture_backend_type_id, G_TYPE_OBJECT);
	return gala_gesture_backend_type_id;
}

GType
gala_gesture_backend_get_type (void)
{
	static gsize gala_gesture_backend_type_id__once = 0;
	if (g_once_init_enter (&gala_gesture_backend_type_id__once)) {
		GType gala_gesture_backend_type_id;
		gala_gesture_backend_type_id = gala_gesture_backend_get_type_once ();
		g_once_init_leave (&gala_gesture_backend_type_id__once, gala_gesture_backend_type_id);
	}
	return gala_gesture_backend_type_id__once;
}

static inline gpointer
gala_gesture_tracker_get_instance_private (GalaGestureTracker* self)
{
	return G_STRUCT_MEMBER_P (self, GalaGestureTracker_private_offset);
}

GalaGestureTracker*
gala_gesture_tracker_construct (GType object_type,
                                gint min_animation_duration,
                                gint max_animation_duration)
{
	GalaGestureTracker * self = NULL;
#line 152 "../src/Gestures/GestureTracker.vala"
	self = (GalaGestureTracker*) g_object_new (object_type, "min-animation-duration", min_animation_duration, "max-animation-duration", max_animation_duration, NULL);
#line 151 "../src/Gestures/GestureTracker.vala"
	return self;
#line 515 "GestureTracker.c"
}

GalaGestureTracker*
gala_gesture_tracker_new (gint min_animation_duration,
                          gint max_animation_duration)
{
#line 151 "../src/Gestures/GestureTracker.vala"
	return gala_gesture_tracker_construct (GALA_TYPE_GESTURE_TRACKER, min_animation_duration, max_animation_duration);
#line 524 "GestureTracker.c"
}

/**
     * Allow to receive touchpad multi-touch gestures.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 159 "../src/Gestures/GestureTracker.vala"
	return self ? g_object_ref (self) : NULL;
#line 535 "GestureTracker.c"
}

static gboolean
_gala_gesture_tracker_gesture_detected_gala_gesture_backend_on_gesture_detected (GalaGestureBackend* _sender,
                                                                                 GalaGesture* gesture,
                                                                                 guint32 timestamp,
                                                                                 gpointer self)
{
	gboolean result;
	result = gala_gesture_tracker_gesture_detected ((GalaGestureTracker*) self, _sender, gesture, timestamp);
#line 160 "../src/Gestures/GestureTracker.vala"
	return result;
#line 548 "GestureTracker.c"
}

static void
_gala_gesture_tracker_gesture_begin_gala_gesture_backend_on_begin (GalaGestureBackend* _sender,
                                                                   gdouble delta,
                                                                   guint64 time,
                                                                   gpointer self)
{
#line 161 "../src/Gestures/GestureTracker.vala"
	gala_gesture_tracker_gesture_begin ((GalaGestureTracker*) self, delta, time);
#line 559 "GestureTracker.c"
}

static void
_gala_gesture_tracker_gesture_update_gala_gesture_backend_on_update (GalaGestureBackend* _sender,
                                                                     gdouble delta,
                                                                     guint64 time,
                                                                     gpointer self)
{
#line 162 "../src/Gestures/GestureTracker.vala"
	gala_gesture_tracker_gesture_update ((GalaGestureTracker*) self, delta, time);
#line 570 "GestureTracker.c"
}

static void
_gala_gesture_tracker_gesture_end_gala_gesture_backend_on_end (GalaGestureBackend* _sender,
                                                               gdouble delta,
                                                               guint64 time,
                                                               gpointer self)
{
#line 163 "../src/Gestures/GestureTracker.vala"
	gala_gesture_tracker_gesture_end ((GalaGestureTracker*) self, delta, time);
#line 581 "GestureTracker.c"
}

void
gala_gesture_tracker_enable_touchpad (GalaGestureTracker* self)
{
	GalaToucheggBackend* _tmp0_;
	GalaToucheggBackend* _tmp1_;
	GalaToucheggBackend* _tmp2_;
	GalaToucheggBackend* _tmp3_;
	GalaToucheggBackend* _tmp4_;
	GalaToucheggBackend* _tmp5_;
#line 158 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/Gestures/GestureTracker.vala"
	_tmp0_ = gala_touchegg_backend_get_default ();
#line 159 "../src/Gestures/GestureTracker.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 159 "../src/Gestures/GestureTracker.vala"
	_g_object_unref0 (self->priv->touchpad_backend);
#line 159 "../src/Gestures/GestureTracker.vala"
	self->priv->touchpad_backend = _tmp1_;
#line 160 "../src/Gestures/GestureTracker.vala"
	_tmp2_ = self->priv->touchpad_backend;
#line 160 "../src/Gestures/GestureTracker.vala"
	g_signal_connect_object ((GalaGestureBackend*) _tmp2_, "on-gesture-detected", (GCallback) _gala_gesture_tracker_gesture_detected_gala_gesture_backend_on_gesture_detected, self, 0);
#line 161 "../src/Gestures/GestureTracker.vala"
	_tmp3_ = self->priv->touchpad_backend;
#line 161 "../src/Gestures/GestureTracker.vala"
	g_signal_connect_object ((GalaGestureBackend*) _tmp3_, "on-begin", (GCallback) _gala_gesture_tracker_gesture_begin_gala_gesture_backend_on_begin, self, 0);
#line 162 "../src/Gestures/GestureTracker.vala"
	_tmp4_ = self->priv->touchpad_backend;
#line 162 "../src/Gestures/GestureTracker.vala"
	g_signal_connect_object ((GalaGestureBackend*) _tmp4_, "on-update", (GCallback) _gala_gesture_tracker_gesture_update_gala_gesture_backend_on_update, self, 0);
#line 163 "../src/Gestures/GestureTracker.vala"
	_tmp5_ = self->priv->touchpad_backend;
#line 163 "../src/Gestures/GestureTracker.vala"
	g_signal_connect_object ((GalaGestureBackend*) _tmp5_, "on-end", (GCallback) _gala_gesture_tracker_gesture_end_gala_gesture_backend_on_end, self, 0);
#line 619 "GestureTracker.c"
}

/**
     * Allow to receive scroll gestures.
     * @param actor Clutter actor that will receive the scroll events.
     * @param orientation If we are interested in the horizontal or vertical axis.
     */
void
gala_gesture_tracker_enable_scroll (GalaGestureTracker* self,
                                    ClutterActor* actor,
                                    ClutterOrientation orientation)
{
	GalaGestureSettings* _tmp0_;
	GalaScrollBackend* _tmp1_;
	GalaScrollBackend* _tmp2_;
	GalaScrollBackend* _tmp3_;
	GalaScrollBackend* _tmp4_;
	GalaScrollBackend* _tmp5_;
#line 171 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (actor != NULL);
#line 172 "../src/Gestures/GestureTracker.vala"
	_tmp0_ = self->priv->_settings;
#line 172 "../src/Gestures/GestureTracker.vala"
	_tmp1_ = gala_scroll_backend_new (actor, orientation, _tmp0_);
#line 172 "../src/Gestures/GestureTracker.vala"
	_g_object_unref0 (self->priv->scroll_backend);
#line 172 "../src/Gestures/GestureTracker.vala"
	self->priv->scroll_backend = _tmp1_;
#line 173 "../src/Gestures/GestureTracker.vala"
	_tmp2_ = self->priv->scroll_backend;
#line 173 "../src/Gestures/GestureTracker.vala"
	g_signal_connect_object ((GalaGestureBackend*) _tmp2_, "on-gesture-detected", (GCallback) _gala_gesture_tracker_gesture_detected_gala_gesture_backend_on_gesture_detected, self, 0);
#line 174 "../src/Gestures/GestureTracker.vala"
	_tmp3_ = self->priv->scroll_backend;
#line 174 "../src/Gestures/GestureTracker.vala"
	g_signal_connect_object ((GalaGestureBackend*) _tmp3_, "on-begin", (GCallback) _gala_gesture_tracker_gesture_begin_gala_gesture_backend_on_begin, self, 0);
#line 175 "../src/Gestures/GestureTracker.vala"
	_tmp4_ = self->priv->scroll_backend;
#line 175 "../src/Gestures/GestureTracker.vala"
	g_signal_connect_object ((GalaGestureBackend*) _tmp4_, "on-update", (GCallback) _gala_gesture_tracker_gesture_update_gala_gesture_backend_on_update, self, 0);
#line 176 "../src/Gestures/GestureTracker.vala"
	_tmp5_ = self->priv->scroll_backend;
#line 176 "../src/Gestures/GestureTracker.vala"
	g_signal_connect_object ((GalaGestureBackend*) _tmp5_, "on-end", (GCallback) _gala_gesture_tracker_gesture_end_gala_gesture_backend_on_end, self, 0);
#line 666 "GestureTracker.c"
}

static Block61Data*
block61_data_ref (Block61Data* _data61_)
{
#line 179 "../src/Gestures/GestureTracker.vala"
	g_atomic_int_inc (&_data61_->_ref_count_);
#line 179 "../src/Gestures/GestureTracker.vala"
	return _data61_;
#line 676 "GestureTracker.c"
}

static void
block61_data_unref (void * _userdata_)
{
	Block61Data* _data61_;
	_data61_ = (Block61Data*) _userdata_;
#line 179 "../src/Gestures/GestureTracker.vala"
	if (g_atomic_int_dec_and_test (&_data61_->_ref_count_)) {
#line 686 "GestureTracker.c"
		GalaGestureTracker* self;
#line 179 "../src/Gestures/GestureTracker.vala"
		self = _data61_->self;
#line 179 "../src/Gestures/GestureTracker.vala"
		(_data61_->on_begin_handler_target_destroy_notify == NULL) ? NULL : (_data61_->on_begin_handler_target_destroy_notify (_data61_->on_begin_handler_target), NULL);
#line 179 "../src/Gestures/GestureTracker.vala"
		_data61_->on_begin_handler = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
		_data61_->on_begin_handler_target = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
		_data61_->on_begin_handler_target_destroy_notify = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
		(_data61_->on_update_handler_target_destroy_notify == NULL) ? NULL : (_data61_->on_update_handler_target_destroy_notify (_data61_->on_update_handler_target), NULL);
#line 179 "../src/Gestures/GestureTracker.vala"
		_data61_->on_update_handler = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
		_data61_->on_update_handler_target = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
		_data61_->on_update_handler_target_destroy_notify = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
		(_data61_->on_end_handler_target_destroy_notify == NULL) ? NULL : (_data61_->on_end_handler_target_destroy_notify (_data61_->on_end_handler_target), NULL);
#line 179 "../src/Gestures/GestureTracker.vala"
		_data61_->on_end_handler = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
		_data61_->on_end_handler_target = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
		_data61_->on_end_handler_target_destroy_notify = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
		_g_object_unref0 (self);
#line 179 "../src/Gestures/GestureTracker.vala"
		g_slice_free (Block61Data, _data61_);
#line 718 "GestureTracker.c"
	}
}

static void
___lambda10_ (Block61Data* _data61_,
              gdouble percentage)
{
	GalaGestureTracker* self;
#line 181 "../src/Gestures/GestureTracker.vala"
	self = _data61_->self;
#line 181 "../src/Gestures/GestureTracker.vala"
	_data61_->on_begin_handler (percentage, _data61_->on_begin_handler_target);
#line 731 "GestureTracker.c"
}

static void
____lambda10__gala_gesture_tracker_on_begin (GalaGestureTracker* _sender,
                                             gdouble percentage,
                                             gpointer self)
{
#line 181 "../src/Gestures/GestureTracker.vala"
	___lambda10_ (self, percentage);
#line 741 "GestureTracker.c"
}

static void
___lambda11_ (Block61Data* _data61_,
              gdouble percentage)
{
	GalaGestureTracker* self;
#line 186 "../src/Gestures/GestureTracker.vala"
	self = _data61_->self;
#line 186 "../src/Gestures/GestureTracker.vala"
	_data61_->on_update_handler (percentage, _data61_->on_update_handler_target);
#line 753 "GestureTracker.c"
}

static void
____lambda11__gala_gesture_tracker_on_update (GalaGestureTracker* _sender,
                                              gdouble percentage,
                                              gpointer self)
{
#line 186 "../src/Gestures/GestureTracker.vala"
	___lambda11_ (self, percentage);
#line 763 "GestureTracker.c"
}

static void
___lambda12_ (Block61Data* _data61_,
              gdouble percentage,
              gint cancel_action,
              gint duration)
{
	GalaGestureTracker* self;
#line 191 "../src/Gestures/GestureTracker.vala"
	self = _data61_->self;
#line 191 "../src/Gestures/GestureTracker.vala"
	_data61_->on_end_handler (percentage, cancel_action, duration, _data61_->on_end_handler_target);
#line 777 "GestureTracker.c"
}

static void
____lambda12__gala_gesture_tracker_on_end (GalaGestureTracker* _sender,
                                           gdouble percentage,
                                           gint completions,
                                           gint calculated_duration,
                                           gpointer self)
{
#line 191 "../src/Gestures/GestureTracker.vala"
	___lambda12_ (self, percentage, completions, calculated_duration);
#line 789 "GestureTracker.c"
}

void
gala_gesture_tracker_connect_handlers (GalaGestureTracker* self,
                                       GalaGestureTrackerOnBegin on_begin_handler,
                                       gpointer on_begin_handler_target,
                                       GDestroyNotify on_begin_handler_target_destroy_notify,
                                       GalaGestureTrackerOnUpdate on_update_handler,
                                       gpointer on_update_handler_target,
                                       GDestroyNotify on_update_handler_target_destroy_notify,
                                       GalaGestureTrackerOnEnd on_end_handler,
                                       gpointer on_end_handler_target,
                                       GDestroyNotify on_end_handler_target_destroy_notify)
{
	Block61Data* _data61_;
#line 179 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_ = g_slice_new0 (Block61Data);
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->_ref_count_ = 1;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->self = g_object_ref (self);
#line 179 "../src/Gestures/GestureTracker.vala"
	(_data61_->on_begin_handler_target_destroy_notify == NULL) ? NULL : (_data61_->on_begin_handler_target_destroy_notify (_data61_->on_begin_handler_target), NULL);
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_begin_handler = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_begin_handler_target = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_begin_handler_target_destroy_notify = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_begin_handler = on_begin_handler;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_begin_handler_target = on_begin_handler_target;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_begin_handler_target_destroy_notify = on_begin_handler_target_destroy_notify;
#line 179 "../src/Gestures/GestureTracker.vala"
	(_data61_->on_update_handler_target_destroy_notify == NULL) ? NULL : (_data61_->on_update_handler_target_destroy_notify (_data61_->on_update_handler_target), NULL);
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_update_handler = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_update_handler_target = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_update_handler_target_destroy_notify = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_update_handler = on_update_handler;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_update_handler_target = on_update_handler_target;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_update_handler_target_destroy_notify = on_update_handler_target_destroy_notify;
#line 179 "../src/Gestures/GestureTracker.vala"
	(_data61_->on_end_handler_target_destroy_notify == NULL) ? NULL : (_data61_->on_end_handler_target_destroy_notify (_data61_->on_end_handler_target), NULL);
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_end_handler = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_end_handler_target = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_end_handler_target_destroy_notify = NULL;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_end_handler = on_end_handler;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_end_handler_target = on_end_handler_target;
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_->on_end_handler_target_destroy_notify = on_end_handler_target_destroy_notify;
#line 180 "../src/Gestures/GestureTracker.vala"
	if (_data61_->on_begin_handler != NULL) {
#line 857 "GestureTracker.c"
		gulong handler_id = 0UL;
		gulong _tmp0_;
		GeeArrayList* _tmp1_;
#line 181 "../src/Gestures/GestureTracker.vala"
		_tmp0_ = g_signal_connect_data (self, "on-begin", (GCallback) ____lambda10__gala_gesture_tracker_on_begin, block61_data_ref (_data61_), (GClosureNotify) block61_data_unref, 0);
#line 181 "../src/Gestures/GestureTracker.vala"
		handler_id = _tmp0_;
#line 182 "../src/Gestures/GestureTracker.vala"
		_tmp1_ = self->priv->handlers;
#line 182 "../src/Gestures/GestureTracker.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (gpointer) ((guintptr) handler_id));
#line 869 "GestureTracker.c"
	}
#line 185 "../src/Gestures/GestureTracker.vala"
	if (_data61_->on_update_handler != NULL) {
#line 873 "GestureTracker.c"
		gulong handler_id = 0UL;
		gulong _tmp2_;
		GeeArrayList* _tmp3_;
#line 186 "../src/Gestures/GestureTracker.vala"
		_tmp2_ = g_signal_connect_data (self, "on-update", (GCallback) ____lambda11__gala_gesture_tracker_on_update, block61_data_ref (_data61_), (GClosureNotify) block61_data_unref, 0);
#line 186 "../src/Gestures/GestureTracker.vala"
		handler_id = _tmp2_;
#line 187 "../src/Gestures/GestureTracker.vala"
		_tmp3_ = self->priv->handlers;
#line 187 "../src/Gestures/GestureTracker.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, (gpointer) ((guintptr) handler_id));
#line 885 "GestureTracker.c"
	}
#line 190 "../src/Gestures/GestureTracker.vala"
	if (_data61_->on_end_handler != NULL) {
#line 889 "GestureTracker.c"
		gulong handler_id = 0UL;
		gulong _tmp4_;
		GeeArrayList* _tmp5_;
#line 191 "../src/Gestures/GestureTracker.vala"
		_tmp4_ = g_signal_connect_data (self, "on-end", (GCallback) ____lambda12__gala_gesture_tracker_on_end, block61_data_ref (_data61_), (GClosureNotify) block61_data_unref, 0);
#line 191 "../src/Gestures/GestureTracker.vala"
		handler_id = _tmp4_;
#line 192 "../src/Gestures/GestureTracker.vala"
		_tmp5_ = self->priv->handlers;
#line 192 "../src/Gestures/GestureTracker.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, (gpointer) ((guintptr) handler_id));
#line 901 "GestureTracker.c"
	}
#line 179 "../src/Gestures/GestureTracker.vala"
	block61_data_unref (_data61_);
#line 179 "../src/Gestures/GestureTracker.vala"
	_data61_ = NULL;
#line 907 "GestureTracker.c"
}

static void
gala_gesture_tracker_disconnect_all_handlers (GalaGestureTracker* self)
{
	GeeArrayList* _tmp8_;
#line 196 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 916 "GestureTracker.c"
	{
		GeeArrayList* _handler_list = NULL;
		GeeArrayList* _tmp0_;
		gint _handler_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _handler_index = 0;
#line 197 "../src/Gestures/GestureTracker.vala"
		_tmp0_ = self->priv->handlers;
#line 197 "../src/Gestures/GestureTracker.vala"
		_handler_list = _tmp0_;
#line 197 "../src/Gestures/GestureTracker.vala"
		_tmp1_ = _handler_list;
#line 197 "../src/Gestures/GestureTracker.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 197 "../src/Gestures/GestureTracker.vala"
		_tmp3_ = _tmp2_;
#line 197 "../src/Gestures/GestureTracker.vala"
		_handler_size = _tmp3_;
#line 197 "../src/Gestures/GestureTracker.vala"
		_handler_index = -1;
#line 197 "../src/Gestures/GestureTracker.vala"
		while (TRUE) {
#line 941 "GestureTracker.c"
			gint _tmp4_;
			gint _tmp5_;
			gulong handler = 0UL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
#line 197 "../src/Gestures/GestureTracker.vala"
			_handler_index = _handler_index + 1;
#line 197 "../src/Gestures/GestureTracker.vala"
			_tmp4_ = _handler_index;
#line 197 "../src/Gestures/GestureTracker.vala"
			_tmp5_ = _handler_size;
#line 197 "../src/Gestures/GestureTracker.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 197 "../src/Gestures/GestureTracker.vala"
				break;
#line 957 "GestureTracker.c"
			}
#line 197 "../src/Gestures/GestureTracker.vala"
			_tmp6_ = _handler_list;
#line 197 "../src/Gestures/GestureTracker.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _handler_index);
#line 197 "../src/Gestures/GestureTracker.vala"
			handler = (gulong) ((guintptr) _tmp7_);
#line 198 "../src/Gestures/GestureTracker.vala"
			g_signal_handler_disconnect ((GObject*) self, handler);
#line 967 "GestureTracker.c"
		}
	}
#line 201 "../src/Gestures/GestureTracker.vala"
	_tmp8_ = self->priv->handlers;
#line 201 "../src/Gestures/GestureTracker.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp8_);
#line 974 "GestureTracker.c"
}

/**
     * Utility method to calculate the current animation value based on the percentage of the
     * gesture performed.
     * Animations are always linear, as they are 1:1 to the user's movement.
     * @param initial_value Animation start value.
     * @param target_value Animation end value.
     * @param percentage Current animation percentage.
     * @param rounded If the returned value should be rounded to match physical pixels.
     * Default to false because some animations, like for example scaling an actor, use intermediate
     * values not divisible by physical pixels.
     * @return The linear animation value at the specified percentage.
     */
gfloat
gala_gesture_tracker_animation_value (gfloat initial_value,
                                      gfloat target_value,
                                      gdouble percentage,
                                      gboolean rounded)
{
	gfloat value = 0.0F;
	gfloat result;
#line 217 "../src/Gestures/GestureTracker.vala"
	value = initial_value;
#line 219 "../src/Gestures/GestureTracker.vala"
	if (initial_value != target_value) {
#line 220 "../src/Gestures/GestureTracker.vala"
		value = ((target_value - initial_value) * ((gfloat) percentage)) + initial_value;
#line 1003 "GestureTracker.c"
	}
#line 223 "../src/Gestures/GestureTracker.vala"
	if (rounded) {
#line 224 "../src/Gestures/GestureTracker.vala"
		value = roundf (value);
#line 1009 "GestureTracker.c"
	}
#line 227 "../src/Gestures/GestureTracker.vala"
	result = value;
#line 227 "../src/Gestures/GestureTracker.vala"
	return result;
#line 1015 "GestureTracker.c"
}

static gboolean
gala_gesture_tracker_gesture_detected (GalaGestureTracker* self,
                                       GalaGestureBackend* backend,
                                       GalaGesture* gesture,
                                       guint32 timestamp)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean result;
#line 230 "../src/Gestures/GestureTracker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 230 "../src/Gestures/GestureTracker.vala"
	g_return_val_if_fail (backend != NULL, FALSE);
#line 230 "../src/Gestures/GestureTracker.vala"
	g_return_val_if_fail (gesture != NULL, FALSE);
#line 231 "../src/Gestures/GestureTracker.vala"
	_tmp1_ = self->priv->_enabled;
#line 231 "../src/Gestures/GestureTracker.vala"
	if (_tmp1_) {
#line 1037 "GestureTracker.c"
		gboolean _tmp2_ = FALSE;
#line 231 "../src/Gestures/GestureTracker.vala"
		g_signal_emit (self, gala_gesture_tracker_signals[GALA_GESTURE_TRACKER_ON_GESTURE_DETECTED_SIGNAL], 0, gesture, &_tmp2_);
#line 231 "../src/Gestures/GestureTracker.vala"
		_tmp0_ = _tmp2_;
#line 1043 "GestureTracker.c"
	} else {
#line 231 "../src/Gestures/GestureTracker.vala"
		_tmp0_ = FALSE;
#line 1047 "GestureTracker.c"
	}
#line 231 "../src/Gestures/GestureTracker.vala"
	if (_tmp0_) {
#line 232 "../src/Gestures/GestureTracker.vala"
		gala_gesture_backend_prepare_gesture_handling (backend);
#line 233 "../src/Gestures/GestureTracker.vala"
		g_signal_emit (self, gala_gesture_tracker_signals[GALA_GESTURE_TRACKER_ON_GESTURE_HANDLED_SIGNAL], 0, gesture, timestamp);
#line 234 "../src/Gestures/GestureTracker.vala"
		result = TRUE;
#line 234 "../src/Gestures/GestureTracker.vala"
		return result;
#line 1059 "GestureTracker.c"
	}
#line 237 "../src/Gestures/GestureTracker.vala"
	result = FALSE;
#line 237 "../src/Gestures/GestureTracker.vala"
	return result;
#line 1065 "GestureTracker.c"
}

static void
gala_gesture_tracker_gesture_begin (GalaGestureTracker* self,
                                    gdouble percentage,
                                    guint64 elapsed_time)
{
	gboolean _tmp0_;
#line 240 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/Gestures/GestureTracker.vala"
	_tmp0_ = self->priv->_enabled;
#line 241 "../src/Gestures/GestureTracker.vala"
	if (_tmp0_) {
#line 242 "../src/Gestures/GestureTracker.vala"
		g_signal_emit (self, gala_gesture_tracker_signals[GALA_GESTURE_TRACKER_ON_BEGIN_SIGNAL], 0, percentage);
#line 1082 "GestureTracker.c"
	}
#line 245 "../src/Gestures/GestureTracker.vala"
	self->priv->previous_percentage = percentage;
#line 246 "../src/Gestures/GestureTracker.vala"
	self->priv->previous_time = elapsed_time;
#line 1088 "GestureTracker.c"
}

static void
gala_gesture_tracker_gesture_update (GalaGestureTracker* self,
                                     gdouble percentage,
                                     guint64 elapsed_time)
{
	gboolean _tmp0_;
#line 249 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 250 "../src/Gestures/GestureTracker.vala"
	if (elapsed_time != self->priv->previous_time) {
#line 1101 "GestureTracker.c"
		gdouble distance = 0.0;
		gdouble time = 0.0;
#line 251 "../src/Gestures/GestureTracker.vala"
		distance = percentage - self->priv->previous_percentage;
#line 252 "../src/Gestures/GestureTracker.vala"
		time = (gdouble) (elapsed_time - self->priv->previous_time);
#line 253 "../src/Gestures/GestureTracker.vala"
		self->priv->velocity = distance / time;
#line 255 "../src/Gestures/GestureTracker.vala"
		if (self->priv->velocity > GALA_GESTURE_TRACKER_MAX_VELOCITY) {
#line 1112 "GestureTracker.c"
			gdouble used_percentage = 0.0;
#line 256 "../src/Gestures/GestureTracker.vala"
			self->priv->velocity = GALA_GESTURE_TRACKER_MAX_VELOCITY;
#line 257 "../src/Gestures/GestureTracker.vala"
			used_percentage = (GALA_GESTURE_TRACKER_MAX_VELOCITY * time) + self->priv->previous_percentage;
#line 258 "../src/Gestures/GestureTracker.vala"
			self->priv->percentage_delta = self->priv->percentage_delta + (percentage - used_percentage);
#line 1120 "GestureTracker.c"
		}
	}
#line 262 "../src/Gestures/GestureTracker.vala"
	_tmp0_ = self->priv->_enabled;
#line 262 "../src/Gestures/GestureTracker.vala"
	if (_tmp0_) {
#line 263 "../src/Gestures/GestureTracker.vala"
		g_signal_emit (self, gala_gesture_tracker_signals[GALA_GESTURE_TRACKER_ON_UPDATE_SIGNAL], 0, gala_gesture_tracker_applied_percentage (percentage, self->priv->percentage_delta));
#line 1129 "GestureTracker.c"
	}
#line 266 "../src/Gestures/GestureTracker.vala"
	self->priv->previous_percentage = percentage;
#line 267 "../src/Gestures/GestureTracker.vala"
	self->priv->previous_time = elapsed_time;
#line 1135 "GestureTracker.c"
}

static void
gala_gesture_tracker_gesture_end (GalaGestureTracker* self,
                                  gdouble percentage,
                                  guint64 elapsed_time)
{
	gdouble end_percentage = 0.0;
	gint completions = 0;
	gboolean _tmp0_ = FALSE;
	gboolean cancel_action = FALSE;
	gint calculated_duration = 0;
	gboolean _tmp3_;
#line 270 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/Gestures/GestureTracker.vala"
	end_percentage = gala_gesture_tracker_applied_percentage (percentage, self->priv->percentage_delta);
#line 272 "../src/Gestures/GestureTracker.vala"
	completions = (gint) end_percentage;
#line 273 "../src/Gestures/GestureTracker.vala"
	if (fabs (end_percentage) < GALA_GESTURE_TRACKER_SUCCESS_PERCENTAGE_THRESHOLD) {
#line 1157 "GestureTracker.c"
		gboolean _tmp1_ = FALSE;
#line 274 "../src/Gestures/GestureTracker.vala"
		if (fabs (end_percentage) <= fabs (self->priv->previous_percentage)) {
#line 274 "../src/Gestures/GestureTracker.vala"
			_tmp1_ = self->priv->velocity < GALA_GESTURE_TRACKER_SUCCESS_VELOCITY_THRESHOLD;
#line 1163 "GestureTracker.c"
		} else {
#line 274 "../src/Gestures/GestureTracker.vala"
			_tmp1_ = FALSE;
#line 1167 "GestureTracker.c"
		}
#line 274 "../src/Gestures/GestureTracker.vala"
		_tmp0_ = _tmp1_;
#line 1171 "GestureTracker.c"
	} else {
#line 273 "../src/Gestures/GestureTracker.vala"
		_tmp0_ = FALSE;
#line 1175 "GestureTracker.c"
	}
#line 273 "../src/Gestures/GestureTracker.vala"
	cancel_action = _tmp0_;
#line 275 "../src/Gestures/GestureTracker.vala"
	calculated_duration = gala_gesture_tracker_calculate_end_animation_duration (self, end_percentage, cancel_action);
#line 277 "../src/Gestures/GestureTracker.vala"
	if (!cancel_action) {
#line 1183 "GestureTracker.c"
		gint _tmp2_ = 0;
#line 278 "../src/Gestures/GestureTracker.vala"
		if (end_percentage < ((gdouble) 0)) {
#line 278 "../src/Gestures/GestureTracker.vala"
			_tmp2_ = -1;
#line 1189 "GestureTracker.c"
		} else {
#line 278 "../src/Gestures/GestureTracker.vala"
			_tmp2_ = 1;
#line 1193 "GestureTracker.c"
		}
#line 278 "../src/Gestures/GestureTracker.vala"
		completions += _tmp2_;
#line 1197 "GestureTracker.c"
	}
#line 281 "../src/Gestures/GestureTracker.vala"
	_tmp3_ = self->priv->_enabled;
#line 281 "../src/Gestures/GestureTracker.vala"
	if (_tmp3_) {
#line 282 "../src/Gestures/GestureTracker.vala"
		g_signal_emit (self, gala_gesture_tracker_signals[GALA_GESTURE_TRACKER_ON_END_SIGNAL], 0, end_percentage, completions, calculated_duration);
#line 1205 "GestureTracker.c"
	}
#line 285 "../src/Gestures/GestureTracker.vala"
	gala_gesture_tracker_disconnect_all_handlers (self);
#line 286 "../src/Gestures/GestureTracker.vala"
	self->priv->previous_percentage = (gdouble) 0;
#line 287 "../src/Gestures/GestureTracker.vala"
	self->priv->previous_time = (guint64) 0;
#line 288 "../src/Gestures/GestureTracker.vala"
	self->priv->percentage_delta = (gdouble) 0;
#line 289 "../src/Gestures/GestureTracker.vala"
	self->priv->velocity = (gdouble) 0;
#line 1217 "GestureTracker.c"
}

static inline gdouble
gala_gesture_tracker_applied_percentage (gdouble percentage,
                                         gdouble percentage_delta)
{
	gdouble result;
#line 293 "../src/Gestures/GestureTracker.vala"
	result = percentage - percentage_delta;
#line 293 "../src/Gestures/GestureTracker.vala"
	return result;
#line 1229 "GestureTracker.c"
}

/**
     * Calculates the end animation duration using the current gesture velocity.
     */
static gint
gala_gesture_tracker_calculate_end_animation_duration (GalaGestureTracker* self,
                                                       gdouble end_percentage,
                                                       gboolean cancel_action)
{
	gdouble _tmp0_ = 0.0;
	gdouble animation_velocity = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble pending_percentage = 0.0;
	gint duration = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint result;
#line 299 "../src/Gestures/GestureTracker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 300 "../src/Gestures/GestureTracker.vala"
	if (self->priv->velocity > GALA_GESTURE_TRACKER_ANIMATION_BASE_VELOCITY) {
#line 301 "../src/Gestures/GestureTracker.vala"
		_tmp0_ = self->priv->velocity;
#line 1254 "GestureTracker.c"
	} else {
#line 302 "../src/Gestures/GestureTracker.vala"
		_tmp0_ = GALA_GESTURE_TRACKER_ANIMATION_BASE_VELOCITY;
#line 1258 "GestureTracker.c"
	}
#line 300 "../src/Gestures/GestureTracker.vala"
	animation_velocity = _tmp0_;
#line 304 "../src/Gestures/GestureTracker.vala"
	if (cancel_action) {
#line 304 "../src/Gestures/GestureTracker.vala"
		_tmp1_ = end_percentage;
#line 1266 "GestureTracker.c"
	} else {
#line 304 "../src/Gestures/GestureTracker.vala"
		_tmp1_ = 1 - end_percentage;
#line 1270 "GestureTracker.c"
	}
#line 304 "../src/Gestures/GestureTracker.vala"
	pending_percentage = _tmp1_;
#line 306 "../src/Gestures/GestureTracker.vala"
	_tmp2_ = self->priv->_min_animation_duration;
#line 306 "../src/Gestures/GestureTracker.vala"
	_tmp3_ = self->priv->_max_animation_duration;
#line 306 "../src/Gestures/GestureTracker.vala"
	duration = CLAMP (((gint) fabs (pending_percentage / animation_velocity)) * GALA_GESTURE_TRACKER_DURATION_MULTIPLIER, _tmp2_, _tmp3_);
#line 308 "../src/Gestures/GestureTracker.vala"
	result = duration;
#line 308 "../src/Gestures/GestureTracker.vala"
	return result;
#line 1284 "GestureTracker.c"
}

GalaGestureSettings*
gala_gesture_tracker_get_settings (GalaGestureTracker* self)
{
	GalaGestureSettings* result;
	GalaGestureSettings* _tmp0_;
#line 69 "../src/Gestures/GestureTracker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../src/Gestures/GestureTracker.vala"
	_tmp0_ = self->priv->_settings;
#line 69 "../src/Gestures/GestureTracker.vala"
	result = _tmp0_;
#line 69 "../src/Gestures/GestureTracker.vala"
	return result;
#line 1300 "GestureTracker.c"
}

static void
gala_gesture_tracker_set_settings (GalaGestureTracker* self,
                                   GalaGestureSettings* value)
{
	GalaGestureSettings* old_value;
#line 69 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/Gestures/GestureTracker.vala"
	old_value = gala_gesture_tracker_get_settings (self);
#line 69 "../src/Gestures/GestureTracker.vala"
	if (old_value != value) {
#line 1314 "GestureTracker.c"
		GalaGestureSettings* _tmp0_;
#line 69 "../src/Gestures/GestureTracker.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 69 "../src/Gestures/GestureTracker.vala"
		_g_object_unref0 (self->priv->_settings);
#line 69 "../src/Gestures/GestureTracker.vala"
		self->priv->_settings = _tmp0_;
#line 69 "../src/Gestures/GestureTracker.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_gesture_tracker_properties[GALA_GESTURE_TRACKER_SETTINGS_PROPERTY]);
#line 1324 "GestureTracker.c"
	}
}

gint
gala_gesture_tracker_get_min_animation_duration (GalaGestureTracker* self)
{
	gint result;
#line 70 "../src/Gestures/GestureTracker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 70 "../src/Gestures/GestureTracker.vala"
	result = self->priv->_min_animation_duration;
#line 70 "../src/Gestures/GestureTracker.vala"
	return result;
#line 1338 "GestureTracker.c"
}

static void
gala_gesture_tracker_set_min_animation_duration (GalaGestureTracker* self,
                                                 gint value)
{
	gint old_value;
#line 70 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/Gestures/GestureTracker.vala"
	old_value = gala_gesture_tracker_get_min_animation_duration (self);
#line 70 "../src/Gestures/GestureTracker.vala"
	if (old_value != value) {
#line 70 "../src/Gestures/GestureTracker.vala"
		self->priv->_min_animation_duration = value;
#line 70 "../src/Gestures/GestureTracker.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_gesture_tracker_properties[GALA_GESTURE_TRACKER_MIN_ANIMATION_DURATION_PROPERTY]);
#line 1356 "GestureTracker.c"
	}
}

gint
gala_gesture_tracker_get_max_animation_duration (GalaGestureTracker* self)
{
	gint result;
#line 71 "../src/Gestures/GestureTracker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 71 "../src/Gestures/GestureTracker.vala"
	result = self->priv->_max_animation_duration;
#line 71 "../src/Gestures/GestureTracker.vala"
	return result;
#line 1370 "GestureTracker.c"
}

static void
gala_gesture_tracker_set_max_animation_duration (GalaGestureTracker* self,
                                                 gint value)
{
	gint old_value;
#line 71 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/Gestures/GestureTracker.vala"
	old_value = gala_gesture_tracker_get_max_animation_duration (self);
#line 71 "../src/Gestures/GestureTracker.vala"
	if (old_value != value) {
#line 71 "../src/Gestures/GestureTracker.vala"
		self->priv->_max_animation_duration = value;
#line 71 "../src/Gestures/GestureTracker.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_gesture_tracker_properties[GALA_GESTURE_TRACKER_MAX_ANIMATION_DURATION_PROPERTY]);
#line 1388 "GestureTracker.c"
	}
}

gboolean
gala_gesture_tracker_get_enabled (GalaGestureTracker* self)
{
	gboolean result;
#line 76 "../src/Gestures/GestureTracker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 76 "../src/Gestures/GestureTracker.vala"
	result = self->priv->_enabled;
#line 76 "../src/Gestures/GestureTracker.vala"
	return result;
#line 1402 "GestureTracker.c"
}

void
gala_gesture_tracker_set_enabled (GalaGestureTracker* self,
                                  gboolean value)
{
	gboolean old_value;
#line 76 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/Gestures/GestureTracker.vala"
	old_value = gala_gesture_tracker_get_enabled (self);
#line 76 "../src/Gestures/GestureTracker.vala"
	if (old_value != value) {
#line 76 "../src/Gestures/GestureTracker.vala"
		self->priv->_enabled = value;
#line 76 "../src/Gestures/GestureTracker.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_gesture_tracker_properties[GALA_GESTURE_TRACKER_ENABLED_PROPERTY]);
#line 1420 "GestureTracker.c"
	}
}

static void
g_cclosure_user_marshal_BOOLEAN__GALA_GESTURE (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__GALA_GESTURE) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__GALA_GESTURE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 42 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (return_value != NULL);
#line 42 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (n_param_values == 2);
#line 42 "../src/Gestures/GestureTracker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 42 "../src/Gestures/GestureTracker.vala"
		data1 = closure->data;
#line 42 "../src/Gestures/GestureTracker.vala"
		data2 = param_values->data[0].v_pointer;
#line 1449 "GestureTracker.c"
	} else {
#line 42 "../src/Gestures/GestureTracker.vala"
		data1 = param_values->data[0].v_pointer;
#line 42 "../src/Gestures/GestureTracker.vala"
		data2 = closure->data;
#line 1455 "GestureTracker.c"
	}
#line 42 "../src/Gestures/GestureTracker.vala"
	callback = (GMarshalFunc_BOOLEAN__GALA_GESTURE) (marshal_data ? marshal_data : cc->callback);
#line 42 "../src/Gestures/GestureTracker.vala"
	v_return = callback (data1, gala_value_get_gesture (param_values + 1), data2);
#line 42 "../src/Gestures/GestureTracker.vala"
	g_value_set_boolean (return_value, v_return);
#line 1463 "GestureTracker.c"
}

static void
g_cclosure_user_marshal_VOID__GALA_GESTURE_UINT (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__GALA_GESTURE_UINT) (gpointer data1, gpointer arg_1, guint32 arg_2, gpointer data2);
	register GMarshalFunc_VOID__GALA_GESTURE_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 42 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (n_param_values == 3);
#line 42 "../src/Gestures/GestureTracker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 42 "../src/Gestures/GestureTracker.vala"
		data1 = closure->data;
#line 42 "../src/Gestures/GestureTracker.vala"
		data2 = param_values->data[0].v_pointer;
#line 1488 "GestureTracker.c"
	} else {
#line 42 "../src/Gestures/GestureTracker.vala"
		data1 = param_values->data[0].v_pointer;
#line 42 "../src/Gestures/GestureTracker.vala"
		data2 = closure->data;
#line 1494 "GestureTracker.c"
	}
#line 42 "../src/Gestures/GestureTracker.vala"
	callback = (GMarshalFunc_VOID__GALA_GESTURE_UINT) (marshal_data ? marshal_data : cc->callback);
#line 42 "../src/Gestures/GestureTracker.vala"
	callback (data1, gala_value_get_gesture (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 1500 "GestureTracker.c"
}

static void
g_cclosure_user_marshal_VOID__DOUBLE_INT_INT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DOUBLE_INT_INT) (gpointer data1, gdouble arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__DOUBLE_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 42 "../src/Gestures/GestureTracker.vala"
	g_return_if_fail (n_param_values == 4);
#line 42 "../src/Gestures/GestureTracker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 42 "../src/Gestures/GestureTracker.vala"
		data1 = closure->data;
#line 42 "../src/Gestures/GestureTracker.vala"
		data2 = param_values->data[0].v_pointer;
#line 1525 "GestureTracker.c"
	} else {
#line 42 "../src/Gestures/GestureTracker.vala"
		data1 = param_values->data[0].v_pointer;
#line 42 "../src/Gestures/GestureTracker.vala"
		data2 = closure->data;
#line 1531 "GestureTracker.c"
	}
#line 42 "../src/Gestures/GestureTracker.vala"
	callback = (GMarshalFunc_VOID__DOUBLE_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 42 "../src/Gestures/GestureTracker.vala"
	callback (data1, g_value_get_double (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 1537 "GestureTracker.c"
}

static GObject *
gala_gesture_tracker_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaGestureTracker * self;
	GalaGestureSettings* _tmp0_;
	GalaGestureSettings* _tmp1_;
	GeeArrayList* _tmp2_;
#line 141 "../src/Gestures/GestureTracker.vala"
	parent_class = G_OBJECT_CLASS (gala_gesture_tracker_parent_class);
#line 141 "../src/Gestures/GestureTracker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 141 "../src/Gestures/GestureTracker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker);
#line 142 "../src/Gestures/GestureTracker.vala"
	_tmp0_ = gala_gesture_settings_new ();
#line 142 "../src/Gestures/GestureTracker.vala"
	_tmp1_ = _tmp0_;
#line 142 "../src/Gestures/GestureTracker.vala"
	gala_gesture_tracker_set_settings (self, _tmp1_);
#line 142 "../src/Gestures/GestureTracker.vala"
	_g_object_unref0 (_tmp1_);
#line 144 "../src/Gestures/GestureTracker.vala"
	_tmp2_ = gee_array_list_new (G_TYPE_ULONG, NULL, NULL, NULL, NULL, NULL);
#line 144 "../src/Gestures/GestureTracker.vala"
	_g_object_unref0 (self->priv->handlers);
#line 144 "../src/Gestures/GestureTracker.vala"
	self->priv->handlers = _tmp2_;
#line 145 "../src/Gestures/GestureTracker.vala"
	self->priv->previous_percentage = (gdouble) 0;
#line 146 "../src/Gestures/GestureTracker.vala"
	self->priv->previous_time = (guint64) 0;
#line 147 "../src/Gestures/GestureTracker.vala"
	self->priv->percentage_delta = (gdouble) 0;
#line 148 "../src/Gestures/GestureTracker.vala"
	self->priv->velocity = (gdouble) 0;
#line 141 "../src/Gestures/GestureTracker.vala"
	return obj;
#line 1581 "GestureTracker.c"
}

static void
gala_gesture_tracker_class_init (GalaGestureTrackerClass * klass,
                                 gpointer klass_data)
{
#line 42 "../src/Gestures/GestureTracker.vala"
	gala_gesture_tracker_parent_class = g_type_class_peek_parent (klass);
#line 42 "../src/Gestures/GestureTracker.vala"
	g_type_class_adjust_private_offset (klass, &GalaGestureTracker_private_offset);
#line 42 "../src/Gestures/GestureTracker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_gesture_tracker_get_property;
#line 42 "../src/Gestures/GestureTracker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_gesture_tracker_set_property;
#line 42 "../src/Gestures/GestureTracker.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_gesture_tracker_constructor;
#line 42 "../src/Gestures/GestureTracker.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_gesture_tracker_finalize;
#line 42 "../src/Gestures/GestureTracker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_GESTURE_TRACKER_SETTINGS_PROPERTY, gala_gesture_tracker_properties[GALA_GESTURE_TRACKER_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", GALA_TYPE_GESTURE_SETTINGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 42 "../src/Gestures/GestureTracker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_GESTURE_TRACKER_MIN_ANIMATION_DURATION_PROPERTY, gala_gesture_tracker_properties[GALA_GESTURE_TRACKER_MIN_ANIMATION_DURATION_PROPERTY] = g_param_spec_int ("min-animation-duration", "min-animation-duration", "min-animation-duration", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 42 "../src/Gestures/GestureTracker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_GESTURE_TRACKER_MAX_ANIMATION_DURATION_PROPERTY, gala_gesture_tracker_properties[GALA_GESTURE_TRACKER_MAX_ANIMATION_DURATION_PROPERTY] = g_param_spec_int ("max-animation-duration", "max-animation-duration", "max-animation-duration", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1606 "GestureTracker.c"
	/**
	     * Property to control when event signals are emitted or not.
	     */
#line 42 "../src/Gestures/GestureTracker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_GESTURE_TRACKER_ENABLED_PROPERTY, gala_gesture_tracker_properties[GALA_GESTURE_TRACKER_ENABLED_PROPERTY] = g_param_spec_boolean ("enabled", "enabled", "enabled", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1612 "GestureTracker.c"
	/**
	     * Emitted when a new gesture is detected.
	     * This should only be used to determine whether the gesture should be handled. This shouldn't
	     * do any preparations instead those should be done in {@link on_gesture_handled}. This is because
	     * the backend might have to do some preparations itself before you are allowed to do some to avoid
	     * conflicts.
	     * @param gesture Information about the gesture.
	     * @return true if the gesture will be handled false otherwise. If false is returned the other
	     * signals may still be emitted but aren't guaranteed to be.
	     */
#line 42 "../src/Gestures/GestureTracker.vala"
	gala_gesture_tracker_signals[GALA_GESTURE_TRACKER_ON_GESTURE_DETECTED_SIGNAL] = g_signal_new ("on-gesture-detected", GALA_TYPE_GESTURE_TRACKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__GALA_GESTURE, G_TYPE_BOOLEAN, 1, GALA_TYPE_GESTURE);
#line 1625 "GestureTracker.c"
	/**
	     * Emitted if true was returned form {@link on_gesture_detected}. This should
	     * be used to do any preparations for gesture handling and to call {@link connect_handlers} to
	     * start receiving updates.
	     * @param gesture the same gesture as in {@link on_gesture_detected}
	     * @param timestamp the timestamp of the event that initiated the gesture or {@link Meta.CURRENT_TIME}.
	     */
#line 42 "../src/Gestures/GestureTracker.vala"
	gala_gesture_tracker_signals[GALA_GESTURE_TRACKER_ON_GESTURE_HANDLED_SIGNAL] = g_signal_new ("on-gesture-handled", GALA_TYPE_GESTURE_TRACKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__GALA_GESTURE_UINT, G_TYPE_NONE, 2, GALA_TYPE_GESTURE, G_TYPE_UINT);
#line 1635 "GestureTracker.c"
	/**
	     * Emitted right after on_gesture_detected with the initial gesture information.
	     * @param percentage Value between 0 and 1.
	     */
#line 42 "../src/Gestures/GestureTracker.vala"
	gala_gesture_tracker_signals[GALA_GESTURE_TRACKER_ON_BEGIN_SIGNAL] = g_signal_new ("on-begin", GALA_TYPE_GESTURE_TRACKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 1642 "GestureTracker.c"
	/**
	     * Called every time the percentage changes.
	     * @param percentage Value between 0 and 1.
	     */
#line 42 "../src/Gestures/GestureTracker.vala"
	gala_gesture_tracker_signals[GALA_GESTURE_TRACKER_ON_UPDATE_SIGNAL] = g_signal_new ("on-update", GALA_TYPE_GESTURE_TRACKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 1649 "GestureTracker.c"
	/**
	     * @param percentage Value between 0 and 1.
	     * @param completions The number of times a full cycle of the gesture was completed in this go. Can be
	     * negative if the gesture was started in one direction but ended in the other. This is used to update
	     * the UI to the according state. 0 for example means that the UI should go back to the same state
	     * it was in before the gesture started.
	     */
#line 42 "../src/Gestures/GestureTracker.vala"
	gala_gesture_tracker_signals[GALA_GESTURE_TRACKER_ON_END_SIGNAL] = g_signal_new ("on-end", GALA_TYPE_GESTURE_TRACKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_INT_INT, G_TYPE_NONE, 3, G_TYPE_DOUBLE, G_TYPE_INT, G_TYPE_INT);
#line 1659 "GestureTracker.c"
}

static void
gala_gesture_tracker_instance_init (GalaGestureTracker * self,
                                    gpointer klass)
{
#line 42 "../src/Gestures/GestureTracker.vala"
	self->priv = gala_gesture_tracker_get_instance_private (self);
#line 76 "../src/Gestures/GestureTracker.vala"
	self->priv->_enabled = TRUE;
#line 1670 "GestureTracker.c"
}

static void
gala_gesture_tracker_finalize (GObject * obj)
{
	GalaGestureTracker * self;
#line 42 "../src/Gestures/GestureTracker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker);
#line 69 "../src/Gestures/GestureTracker.vala"
	_g_object_unref0 (self->priv->_settings);
#line 127 "../src/Gestures/GestureTracker.vala"
	_g_object_unref0 (self->priv->touchpad_backend);
#line 132 "../src/Gestures/GestureTracker.vala"
	_g_object_unref0 (self->priv->scroll_backend);
#line 134 "../src/Gestures/GestureTracker.vala"
	_g_object_unref0 (self->priv->handlers);
#line 42 "../src/Gestures/GestureTracker.vala"
	G_OBJECT_CLASS (gala_gesture_tracker_parent_class)->finalize (obj);
#line 1689 "GestureTracker.c"
}

/**
 * Allow to use multi-touch gestures from different sources (backends).
 * Usage:
 *
 *  * Create a new instance of the class
 *  * Use the enable_* methods to enable different backends\
 *  * Connect the on_gesture_detected to your code
 *  * When on_gesture_detected is emitted, if you want to handle the gesture, call connect_handlers to start receiving events
 *  * on_begin will be emitted once right after on_gesture_detected
 *  * on_update will be emitted 0 or more times
 *  * on_end will be emitted once when the gesture end
 *  * When on_end is emitted, the handler connected with connect_handlers will be automatically disconnected and you will only receive on_gesture_detected signals
 *  * The enabled flag is usually disabled on_end and re-enabled once the end animation finish. In this way, new gestures are not received while animating
 */
 G_GNUC_NO_INLINE static GType
gala_gesture_tracker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaGestureTrackerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_gesture_tracker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaGestureTracker), 0, (GInstanceInitFunc) gala_gesture_tracker_instance_init, NULL };
	GType gala_gesture_tracker_type_id;
	gala_gesture_tracker_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaGestureTracker", &g_define_type_info, 0);
	GalaGestureTracker_private_offset = g_type_add_instance_private (gala_gesture_tracker_type_id, sizeof (GalaGestureTrackerPrivate));
	return gala_gesture_tracker_type_id;
}

GType
gala_gesture_tracker_get_type (void)
{
	static gsize gala_gesture_tracker_type_id__once = 0;
	if (g_once_init_enter (&gala_gesture_tracker_type_id__once)) {
		GType gala_gesture_tracker_type_id;
		gala_gesture_tracker_type_id = gala_gesture_tracker_get_type_once ();
		g_once_init_leave (&gala_gesture_tracker_type_id__once, gala_gesture_tracker_type_id);
	}
	return gala_gesture_tracker_type_id__once;
}

static void
_vala_gala_gesture_tracker_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaGestureTracker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker);
#line 42 "../src/Gestures/GestureTracker.vala"
	switch (property_id) {
#line 42 "../src/Gestures/GestureTracker.vala"
		case GALA_GESTURE_TRACKER_SETTINGS_PROPERTY:
#line 42 "../src/Gestures/GestureTracker.vala"
		g_value_set_object (value, gala_gesture_tracker_get_settings (self));
#line 42 "../src/Gestures/GestureTracker.vala"
		break;
#line 42 "../src/Gestures/GestureTracker.vala"
		case GALA_GESTURE_TRACKER_MIN_ANIMATION_DURATION_PROPERTY:
#line 42 "../src/Gestures/GestureTracker.vala"
		g_value_set_int (value, gala_gesture_tracker_get_min_animation_duration (self));
#line 42 "../src/Gestures/GestureTracker.vala"
		break;
#line 42 "../src/Gestures/GestureTracker.vala"
		case GALA_GESTURE_TRACKER_MAX_ANIMATION_DURATION_PROPERTY:
#line 42 "../src/Gestures/GestureTracker.vala"
		g_value_set_int (value, gala_gesture_tracker_get_max_animation_duration (self));
#line 42 "../src/Gestures/GestureTracker.vala"
		break;
#line 42 "../src/Gestures/GestureTracker.vala"
		case GALA_GESTURE_TRACKER_ENABLED_PROPERTY:
#line 42 "../src/Gestures/GestureTracker.vala"
		g_value_set_boolean (value, gala_gesture_tracker_get_enabled (self));
#line 42 "../src/Gestures/GestureTracker.vala"
		break;
#line 1762 "GestureTracker.c"
		default:
#line 42 "../src/Gestures/GestureTracker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../src/Gestures/GestureTracker.vala"
		break;
#line 1768 "GestureTracker.c"
	}
}

static void
_vala_gala_gesture_tracker_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaGestureTracker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker);
#line 42 "../src/Gestures/GestureTracker.vala"
	switch (property_id) {
#line 42 "../src/Gestures/GestureTracker.vala"
		case GALA_GESTURE_TRACKER_SETTINGS_PROPERTY:
#line 42 "../src/Gestures/GestureTracker.vala"
		gala_gesture_tracker_set_settings (self, g_value_get_object (value));
#line 42 "../src/Gestures/GestureTracker.vala"
		break;
#line 42 "../src/Gestures/GestureTracker.vala"
		case GALA_GESTURE_TRACKER_MIN_ANIMATION_DURATION_PROPERTY:
#line 42 "../src/Gestures/GestureTracker.vala"
		gala_gesture_tracker_set_min_animation_duration (self, g_value_get_int (value));
#line 42 "../src/Gestures/GestureTracker.vala"
		break;
#line 42 "../src/Gestures/GestureTracker.vala"
		case GALA_GESTURE_TRACKER_MAX_ANIMATION_DURATION_PROPERTY:
#line 42 "../src/Gestures/GestureTracker.vala"
		gala_gesture_tracker_set_max_animation_duration (self, g_value_get_int (value));
#line 42 "../src/Gestures/GestureTracker.vala"
		break;
#line 42 "../src/Gestures/GestureTracker.vala"
		case GALA_GESTURE_TRACKER_ENABLED_PROPERTY:
#line 42 "../src/Gestures/GestureTracker.vala"
		gala_gesture_tracker_set_enabled (self, g_value_get_boolean (value));
#line 42 "../src/Gestures/GestureTracker.vala"
		break;
#line 1806 "GestureTracker.c"
		default:
#line 42 "../src/Gestures/GestureTracker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../src/Gestures/GestureTracker.vala"
		break;
#line 1812 "GestureTracker.c"
	}
}

